#include <stdio.h>
#include <linux/if_ether.h>
#include "librawsocket.h"
char ifname[16];
int sockraw;



typedef struct{
unsigned char dst[6];
unsigned char src[6];

}macHead;

typedef struct{
unsigned char type;
unsigned char seq;
unsigned short len;

}controlHead;

typedef struct {
     macHead	    mac;
    controlHead		ctrl;
    char		    payload[0];
} __attribute__((__packed__)) own_packet;



unsigned char dst_ethaddr[ETH_ALEN]={0x55,0xaa,0x55,0xaa,0x55,0xaa};
unsigned char src_ethaddr[ETH_ALEN]={0xaa,0x55,0xaa,0x55,0xaa,0x55};

unsigned short cal_chksum(unsigned short *addr,int len)
{
   int nleft=len;
   int sum=0;
   unsigned short *w=addr;
   unsigned short answer=0;

   while(nleft>1)
   {       sum+=*w++;
           nleft-=2; }
   if( nleft==1)
   {       *(unsigned char *)(&answer)=*(unsigned char *)w;
           sum+=answer; }
   sum=(sum>>16)+(sum&0xffff);
   sum+=(sum>>16);
   answer=~sum;
   return answer;
}



void displayHead(unsigned char * buf,int size)
{
       int i;

   for(i=0;i<size;i++)
   {      
    if((0==(i%16))&&(i>0)) printf("\n");
     printf("%02hhx ",buf[i]); 
   }
  printf("\n");
}

int sendAndAcq(char *buf,size_t payloadLen,int sockfd,unsigned char seq)
{
		own_packet *sendP=(own_packet *)buf;
		own_packet *recP;
		size_t sendLen=payloadLen+sizeof(macHead)+sizeof(controlHead);
		unsigned char recBuff[1500];
		int ret;
		if(payloadLen>(1500-sizeof(macHead)-sizeof(controlHead)))
			return -5;
		
		sendP->ctrl.seq=seq;
		sendP->ctrl.len=htons(payloadLen);
  //      displayHead(buf,673);
		if(ret = send_rawpacket(sockfd, buf, sendLen)!=sendLen)
		{
			printf("send_rawpacket ret is %d,sendLen is %u\n",ret,sendLen);
			return -6;
		}
        
        while(1)
        {
        	if ((ret = recv_rawpacket(sockfd, recBuff, sizeof(recBuff))) < 0)
	   			return -1;
            
			recP=(own_packet*)recBuff;
   //         displayHead(recBuff,16);
			if(memcmp(recP->mac.dst,dst_ethaddr,ETH_ALEN)!=0)
				continue;
			if(recP->ctrl.seq!=sendP->ctrl.seq)
				return  -3;
			if(recP->ctrl.type!=0x2)	
				return -4;
            break;
       }
			
		return 0;

}
char cmdStr[100];
int main(int argc, char** argv)
{
	int ret;
	int rc;
    int len;
	char filename[256]="";
	FILE *fp;
	char buf1500[1500];
	int payloadSize=0;
	int headSize=0;
	unsigned char count=0;
	own_packet * sendP=(own_packet*)buf1500;
	own_packet * recP=(own_packet*)buf1500;
	printf("argc is %d\n",argc);
    printf("argv[1] is %s\n" ,argv[1]) ; 
    printf("argv[2] is %s\n" ,argv[2]) ; 
	if(argc==1)
		strcpy(filename,"/tmp/rwsock");
    else
		strcpy(filename,argv[1]);
    if(argc==3)
     	strcpy(ifname,argv[2]);
    else
        strcpy(ifname,"eth1");
        
    if((sockraw = create_rawsocket(ETH_P_ALL)) == -1)
    {
          printf("create rawsocket erro\n\r");
	     return sockraw;
    }
     if((ret = bind_rawsocket(ifname, sockraw,ETH_P_ALL)) == -1)
     {
        printf("bind rawsocket erro\n\r");
		return ret;
     }
     printf("filename is %s\r\n",filename);
	 if((fp=fopen( filename, "rb"))==NULL)
	 {
	 	printf("file open erro\n\r");
	 	return -1;
	 }
     
	lseek(fp,0,SEEK_SET);
    
	headSize=(sizeof(macHead)+sizeof(controlHead));
    memcpy(&sendP->mac.dst, dst_ethaddr, ETH_ALEN);
    memcpy(&sendP->mac.src, src_ethaddr, ETH_ALEN);
	sendP->ctrl.type=0x01;
	printf("head is setted headSize is %d\n",headSize);


    while(1)
    { 
//        printf(" read count %u\n",count);
        payloadSize=1500-headSize;
        len = fread(&buf1500[headSize],sizeof(unsigned char), payloadSize,fp);
              
        if((len!=payloadSize)&&(len!=0))
        {
            printf("len is %d\n",len);
            if (ferror(fp))/*test for an error on the stream*/
             {
                printf("Error reading from DUMMY.FIL\n");
     
		       break;
             }
             sendP->ctrl.type=0x03; 
       }
        else if(feof(fp))
        { 
           printf("file end and len is %d\n",len);
           break;
        }
        payloadSize=len;

  //      printf("payloadSize=%d\n",payloadSize);
        if(ret=sendAndAcq(buf1500,payloadSize,sockraw,count)!=0)
        {
            printf("sendAndAcq failed ,the return value is %d\n",ret);
            return -1;
                
       }
       count++;
    
   }

    sprintf(cmdStr,"nvram_set rawsock_c 1");
    system(cmdStr);
    clearerr(fp);
    fclose(fp);
    return 0;
}

